diff -r 82fcd4bea972 src/xfrm.c
--- a/src/xfrm.c	Fri Jan 11 16:55:08 2008 +0100
+++ b/src/xfrm.c	Fri Jan 11 17:02:25 2008 +0100
@@ -56,7 +56,7 @@
 #include "conf.h"
 #include "ipsec.h"
 
-#define XFRM_DEBUG_LEVEL 1
+#define XFRM_DEBUG_LEVEL 2
 
 #if XFRM_DEBUG_LEVEL >= 1
 #define XDBG dbg
@@ -1555,7 +1555,7 @@ static int xfrm_bule_bce_update(const st
 	int res = -1;
 	pthread_rwlock_rdlock(&mn_lock);
 	if ((hai = mn_get_home_addr(our_addr)) != NULL) {
-		if ((e = bul_get(hai, NULL, peer_addr)) != NULL) {
+		if ((e = bul_get(hai, NULL, peer_addr, MCOA_NO_BID)) != NULL) {
 			if (e->type == BUL_ENTRY &&
 			    !_xfrm_add_bule_bce(our_addr, peer_addr, replace))
 				res = 0;
@@ -1582,30 +1582,34 @@ int xfrm_add_bce(const struct in6_addr *
 int xfrm_add_bce(const struct in6_addr *our_addr,
 		 const struct in6_addr *peer_addr,
 		 const struct in6_addr *coa,
-		 int replace)
+		 int replace,
+		 int create)
 {
 	struct xfrm_selector sel;
 
 	/* Create policy for outbound RO data traffic */
-	set_selector(peer_addr, our_addr, 0, 0, 0, 0, &sel);
-	if (xfrm_state_add(&sel, IPPROTO_ROUTING, coa, replace, 0)){
-		/* 
-		 * WORKAROUND 
-		 * In some cases, MN fail to add it because of the state
-		 * inserted by kernel when notifying aquire. So,update it.
-		 */
-		if (xfrm_state_add(&sel, IPPROTO_ROUTING, coa, 1, 0))
-			return -1;
-	}
-	set_selector(our_addr, peer_addr, 0, 0, 0, 0, &sel);
-	if (xfrm_state_add(&sel, IPPROTO_DSTOPTS, coa, replace, 0)){
-		/* 
-		 * WORKAROUND 
-		 * In some cases, MN fail to add it because of the state
-		 * inserted by kernel when notifying aquire. So,update it.
-		 */
-		if (xfrm_state_add(&sel, IPPROTO_DSTOPTS, coa, 1, 0))
-		return -1;
+	if (create || replace) {
+		set_selector(peer_addr, our_addr, 0, 0, 0, 0, &sel);
+		if (xfrm_state_add(&sel, IPPROTO_ROUTING, coa, replace, 0)){
+			/* 
+			 * WORKAROUND 
+			 * In some cases, MN fail to add it because of the state
+			 * inserted by kernel when notifying aquire. So,update it.
+			 */
+			if (xfrm_state_add(&sel, IPPROTO_ROUTING, coa, 1, 0))
+				return -1;
+		}
+	
+		set_selector(our_addr, peer_addr, 0, 0, 0, 0, &sel);
+		if (xfrm_state_add(&sel, IPPROTO_DSTOPTS, coa, replace, 0)){
+			/* 
+			 * WORKAROUND 
+			 * In some cases, MN fail to add it because of the state
+			 * inserted by kernel when notifying aquire. So,update it.
+			 */
+			if (xfrm_state_add(&sel, IPPROTO_DSTOPTS, coa, 1, 0))
+				return -1;
+		}
 	}
 	if (is_mn() && !xfrm_bule_bce_update(our_addr, peer_addr, replace))
 		return 0;
@@ -1614,7 +1618,8 @@ int xfrm_add_bce(const struct in6_addr *
 				       _ha_mn_ipsec_pol_mod, NULL) < 0)
 			return -1;
 	}
-	_xfrm_add_bce(our_addr, peer_addr, replace);
+	if (create || replace)
+		_xfrm_add_bce(our_addr, peer_addr, replace);
 	return 0;
 }
 
@@ -1643,7 +1648,7 @@ void xfrm_del_bce(const struct in6_addr 
 		/* for MN-MN communications, checking BUL to insert RO policy */
 		pthread_rwlock_rdlock(&mn_lock);
 		if ((hai = mn_get_home_addr(our_addr)) != NULL) {
-			if ((e = bul_get(hai, NULL, peer_addr)) != NULL) {
+			if ((e = bul_get(hai, NULL, peer_addr, MCOA_NO_BID)) != NULL) {
 				if (e->type == BUL_ENTRY)
 			    	_xfrm_add_bule_bce(our_addr, peer_addr, 0);
 			}
@@ -1736,7 +1741,7 @@ static int _xfrm_bce_reset(struct bulent
 static int _xfrm_bce_reset(struct bulentry *bule)
 {
 	/* for MN - MN communication */
-	struct bcentry *bce = bcache_get(&bule->hoa, &bule->peer_addr);
+	struct bcentry *bce = bcache_get(&bule->hoa, &bule->peer_addr, MCOA_NO_BID);
 	int res = 0;
 	if (!bce)
 		return 0;
@@ -1754,21 +1759,34 @@ static int _xfrm_del_bule_data(struct bu
 static int _xfrm_del_bule_data(struct bulentry *bule)
 {
 	struct xfrm_selector sel;
+	int bule_exists = mcoa_bule_count(bule);
 	int prio;
 
-	set_selector(&bule->peer_addr, &bule->hoa, 0, 0, 0, 0, &sel);
-	xfrm_state_del(IPPROTO_DSTOPTS,  &sel);
+	/* MCoA
+	 * XFRM states are deleted only when the last BULE for 
+	 * the same peer is deleted, or when returning home
+	 */
+	if (!bule_exists || !bule->home->reg_mcoa || bule->home->at_home) {
+		XDBG2("Last entry for the peer, deleting XFRM states\n");
+		set_selector(&bule->peer_addr, &bule->hoa, 0, 0, 0, 0, &sel);
+		xfrm_state_del(IPPROTO_DSTOPTS, &sel);
+	}
 
 	if (bule->home->home_reg_status != HOME_REG_NONE && 
 	    mn_has_cn_ro_pol(bule)) {
 		struct xfrm_user_tmpl tmpl;
 		create_trig_dstopt_tmpl(&tmpl, &bule->peer_addr, &bule->hoa);
+		/* MCoA: replaced bule->home->if_tunnel with bule->if_tunnel */
 		set_selector(&bule->peer_addr, &bule->hoa,
-			     0, 0, 0, bule->home->if_tunnel, &sel);
+			     0, 0, 0, bule->if_tunnel, &sel);
 		xfrm_mip_policy_add(&sel, 1, XFRM_POLICY_OUT,
 				    XFRM_POLICY_ALLOW, MIP6_PRIO_RO_TRIG, &tmpl, 1);
-	} else
-		_mn_bule_ro_pol_del(bule, bule->home->if_tunnel);
+	} else if(!bule_exists || !bule->home->reg_mcoa || bule->home->at_home) {
+		/* MCoA: policies deleted only if this is the last BULE 
+		 * for the same peer, or when returning home */
+		/* MCoA: replaced bule->home->if_tunnel with bule->if_tunnel */
+		_mn_bule_ro_pol_del(bule, bule->if_tunnel);
+	}
 
 	if (!(bule->flags & IP6_MH_BU_HOME))
 		_xfrm_bce_reset(bule);
@@ -1779,20 +1797,25 @@ static int _xfrm_del_bule_data(struct bu
 	/* MN - CN/HA case, BU out */
 	prio = (bule->flags & IP6_MH_BU_HOME ?
 		MIP6_PRIO_HOME_SIG : MIP6_PRIO_RO_SIG);
-	if (bule->flags & IP6_MH_BU_ACK) {
+	if ((bule->flags & IP6_MH_BU_ACK) 
+	    && (!bule_exists ||	!bule->home->reg_mcoa 
+		|| bule->home->at_home)) {
 		set_selector(&bule->hoa, &bule->peer_addr, IPPROTO_MH,
 			     IP6_MH_TYPE_BACK, 0, 0, &sel);
 		if (xfrm_mip_policy_add(&sel, 1, XFRM_POLICY_IN,
 					XFRM_POLICY_ALLOW, prio, NULL, 0))
 			return -1;
 	}
-	set_selector(&bule->peer_addr, &bule->hoa, IPPROTO_MH,
-		     IP6_MH_TYPE_BU, 0, 0, &sel);
-	if (xfrm_mip_policy_add(&sel, 1, XFRM_POLICY_OUT,
-				XFRM_POLICY_ALLOW, prio, NULL, 0))
-		return -1;
+	if (!bule_exists || !bule->home->reg_mcoa 
+	    || bule->home->at_home) {
+		set_selector(&bule->peer_addr, &bule->hoa, IPPROTO_MH,
+			     IP6_MH_TYPE_BU, 0, 0, &sel);
+		if (xfrm_mip_policy_add(&sel, 1, XFRM_POLICY_OUT, 
+				    XFRM_POLICY_ALLOW, prio, NULL, 0))
+			return -1;
+		bule->xfrm_state &= ~BUL_XFRM_STATE_DATA;
+	}
 
-	bule->xfrm_state &= ~BUL_XFRM_STATE_DATA;
 	return 0;
 }
 
@@ -1817,7 +1840,14 @@ void xfrm_del_bule(struct bulentry *bule
 {
 	if (bule->xfrm_state & BUL_XFRM_STATE_DATA)
 		_xfrm_del_bule_data(bule);
-	_xfrm_del_bule_sig(bule);
+	/* MCoA
+	 * XFRM policies are deleted only when the last BULE for the 
+	 * same peer is deleted, or when returning home
+	 */
+	if (mcoa_bule_count(bule) == 0 || bule->home->at_home) {
+		XDBG2("Last entry for the peer, deleting XFRM policies\n");
+		_xfrm_del_bule_sig(bule);
+	}
 }
 
 /* before sending BU, MN should insert policy/state only for BU/BA */
@@ -1829,14 +1859,26 @@ int xfrm_pre_bu_add_bule(struct bulentry
 	int rdata = bule->xfrm_state & BUL_XFRM_STATE_DATA;
 	int prio;
 	int exist = 0;
+	int bule_count = mcoa_bule_count(bule);
 
 	if (bule->flags & IP6_MH_BU_HOME) {
 		struct home_addr_info *hai = bule->home;
 		if (hai->home_block & HOME_LINK_BLOCK)
 			xfrm_unblock_link(hai);
-		xfrm_block_link(hai);
-		if (hai->mob_rtr && !(hai->home_block & NEMO_FWD_BLOCK))
-			xfrm_block_fwd(hai);
+		if (bule->home_block & HOME_LINK_BLOCK)
+			xfrm_unblock_bule_link(bule);
+		if (!hai->reg_mcoa)
+			xfrm_block_link(hai);
+		else
+			xfrm_block_bule_link(bule);
+		if (hai->mob_rtr) {
+			if (!hai->reg_mcoa && 
+			    !(hai->home_block & NEMO_FWD_BLOCK))
+				xfrm_block_fwd(hai);
+			else if (hai->reg_mcoa &&
+			         !(bule->home_block & NEMO_FWD_BLOCK))
+				bule_block_fwd(bule);
+		}
 	}
 	if (IN6_ARE_ADDR_EQUAL(&bule->hoa, &bule->coa)) {
 		if (rdata)
@@ -1850,25 +1892,32 @@ int xfrm_pre_bu_add_bule(struct bulentry
 			return -1;
 	}
 	/* MN - CN/HA case, BU out */
-	prio = (bule->flags & IP6_MH_BU_HOME ?
-		MIP6_PRIO_HOME_SIG : MIP6_PRIO_RO_SIG);
-	if (bule->flags & IP6_MH_BU_ACK) {
-		create_rh_tmpl(&tmpl);
-		set_selector(&bule->hoa, &bule->peer_addr, IPPROTO_MH,
-			     IP6_MH_TYPE_BACK, 0, 0, &sel);
-		if (xfrm_mip_policy_add(&sel, rsig, XFRM_POLICY_IN,
+	if (bule_count == 1) {
+		/* MCoA
+		 * If another BULE already exists for this HoA/HA addr
+		 * we do not need to install the policies once again
+		 */
+		prio = (bule->flags & IP6_MH_BU_HOME ?
+			MIP6_PRIO_HOME_SIG : MIP6_PRIO_RO_SIG);
+		if (bule->flags & IP6_MH_BU_ACK) {
+			create_rh_tmpl(&tmpl);
+			set_selector(&bule->hoa, &bule->peer_addr, IPPROTO_MH,
+				     IP6_MH_TYPE_BACK, 0, 0, &sel);
+			if (xfrm_mip_policy_add(&sel, rsig, XFRM_POLICY_IN,
+						XFRM_POLICY_ALLOW, prio, &tmpl, 1))
+				return -1;
+		}
+		create_dstopt_tmpl(&tmpl, &bule->peer_addr, &bule->hoa);
+		set_selector(&bule->peer_addr, &bule->hoa, IPPROTO_MH,
+		     IP6_MH_TYPE_BU, 0, 0, &sel);
+		if (xfrm_mip_policy_add(&sel, rsig, XFRM_POLICY_OUT,
 					XFRM_POLICY_ALLOW, prio, &tmpl, 1))
 			return -1;
 	}
-	create_dstopt_tmpl(&tmpl, &bule->peer_addr, &bule->hoa);
-	set_selector(&bule->peer_addr, &bule->hoa, IPPROTO_MH,
-		     IP6_MH_TYPE_BU, 0, 0, &sel);
-	if (xfrm_mip_policy_add(&sel, rsig, XFRM_POLICY_OUT,
-				XFRM_POLICY_ALLOW, prio, &tmpl, 1))
-		return -1;
 
 	if (!(bule->flags & IP6_MH_BU_HOME)) {
-		struct bcentry *bce = bcache_get(&bule->hoa, &bule->peer_addr);
+		struct bcentry *bce = bcache_get(&bule->hoa, &bule->peer_addr, 
+						 MCOA_NO_BID);
 		if (bce) {
 			if (bce->type >  BCE_NONCE_BLOCK &&
 			    _xfrm_add_bce(&bule->hoa, &bule->peer_addr, 1)) {
@@ -1879,11 +1928,16 @@ int xfrm_pre_bu_add_bule(struct bulentry
 			exist = 1;
 		}
 	}
-	if(!exist &&_mn_bule_ro_pol_add(bule, bule->home->if_tunnel, rdata))
+	/* MCoA: Replaced bule->home->if_tunnel with bule->if_tunnel */
+	if(!exist && bule_count == 1
+	   && _mn_bule_ro_pol_add(bule, bule->if_tunnel, rdata))
 		return -1;
 	set_selector(&bule->peer_addr, &bule->hoa, 0, 0, 0, 0, &sel);
 	/* XXX: acquired state is already inserted */
-	if (!(bule->flags & IP6_MH_BU_HOME)) {
+	/* MCoA: Add the states if there is only 1 BCE for the peer,
+	 * otherwise just update the CoA
+	 */
+	if (!(bule->flags & IP6_MH_BU_HOME) || mcoa_bule_count(bule) > 1) {
 		XDBG2("%s: original rdata = %d\n", __FUNCTION__, rdata);
 		rdata = 1;
 	}
@@ -1902,15 +1956,20 @@ int xfrm_post_ba_mod_bule(struct bulentr
 		struct home_addr_info *hai = bule->home;
 		if (hai->home_block & HOME_LINK_BLOCK)
 			xfrm_unblock_link(hai);
+		if (bule->home_block & HOME_LINK_BLOCK)
+			xfrm_unblock_bule_link(bule);
 		if (hai->home_block & NEMO_FWD_BLOCK)
 			xfrm_unblock_fwd(hai);
+		if (bule->home_block & NEMO_FWD_BLOCK)
+			bule_unblock_fwd(bule);
 	}
 	/* check if XFRM policies and states have already been cleaned up */
 	if (IN6_ARE_ADDR_EQUAL(&bule->hoa, &bule->coa))
 		return 0;
 
 	if (!(bule->flags & IP6_MH_BU_HOME)) {
-		struct bcentry *bce = bcache_get(&bule->hoa, &bule->peer_addr);
+		struct bcentry *bce = bcache_get(&bule->hoa, &bule->peer_addr,
+						 MCOA_NO_BID);
 		if (bce) {
 			if (bce->type >  BCE_NONCE_BLOCK &&
 			    _xfrm_add_bule_bce(&bule->hoa,
@@ -1925,11 +1984,27 @@ int xfrm_post_ba_mod_bule(struct bulentr
 	}
 	prio = (bule->flags & IP6_MH_BU_HOME ?
 		MIP6_PRIO_HOME_DATA : MIP6_PRIO_RO_BULE_DATA);
-	set_selector(&bule->peer_addr, &bule->hoa, 0, 0, 0,
-		     bule->home->if_tunnel, &sel);
-	create_dstopt_tmpl(&tmpls[0], &bule->peer_addr, &bule->hoa);
-	ret = xfrm_mip_policy_add(&sel, 1, XFRM_POLICY_OUT,
-				   XFRM_POLICY_ALLOW, prio, tmpls, 1);
+
+	/* MCoA: Replaced bule->home->if_tunnel with bule->if_tunnel */
+	set_selector(&bule->peer_addr, &bule->hoa, 0, 0, 0, 
+		     bule->if_tunnel, &sel);
+
+	/* MCoA TODO1: to update according to the latest draft.
+	 * When MCoA is used, do not use HAO dest. option 
+	 * for traffic from the MN/MR to the HA. Tunnel packets 
+	 * instead.
+	 */
+	if(bule->home->reg_mcoa) {
+		ret = xfrm_mip_policy_add(&sel, 1, XFRM_POLICY_OUT, 
+					   XFRM_POLICY_ALLOW, prio, 
+					   NULL, 0);
+	} else {
+		create_dstopt_tmpl(&tmpls[0], &bule->peer_addr, &bule->hoa);
+		ret = xfrm_mip_policy_add(&sel, 1, XFRM_POLICY_OUT,
+					  XFRM_POLICY_ALLOW, prio, 
+					  tmpls, 1);
+	}
+
 	if (ret)
 		XDBG("failed to insert outbound policy\n");
 
@@ -2126,6 +2201,31 @@ void xfrm_cleanup(void)
 	xfrm_cn_cleanup();
 }
 
+/* blocking all payload packets from MN via a specific interface */
+int xfrm_block_bule_link(struct bulentry *bule)
+{
+	int ret = 0;
+	struct xfrm_selector sel;
+	bule->home_block |= HOME_LINK_BLOCK;
+	/* allow MN to send NA messages */
+	/* RK: such policy is already installed in xfrm_cn_init at startup,
+	 * so we update it (update field to 1) */
+	set_selector(&in6addr_any, &in6addr_any, IPPROTO_ICMPV6, 
+		     ND_NEIGHBOR_ADVERT, 0, bule->if_coa, &sel);
+	if ((ret = xfrm_mip_policy_add(&sel, 1 /* update */, XFRM_POLICY_OUT, 
+				       XFRM_POLICY_ALLOW,
+				       MIP6_PRIO_HOME_SIG_ANY, NULL, 0)))
+		return ret;
+
+	/* block any packets from HoA to the CN */
+	set_selector(&in6addr_any, &in6addr_any, 0, 0, 0, bule->if_coa, &sel);
+	if ((ret = xfrm_mip_policy_add(&sel, 0, XFRM_POLICY_OUT, 
+				   XFRM_POLICY_BLOCK,
+				   MIP6_PRIO_HOME_BLOCK, NULL, 0)))
+		return ret;
+	return ret;
+}
+
 /* blocking all payload packets from MN */
 int xfrm_block_link(struct home_addr_info *hai)
 {
@@ -2141,6 +2241,21 @@ int xfrm_block_link(struct home_addr_inf
 				       MIP6_PRIO_HOME_BLOCK, NULL, 0)))
 		return ret;
 	return ret;
+}
+
+void xfrm_unblock_bule_link(struct bulentry *bule)
+{
+	struct xfrm_selector sel;
+	set_selector(&in6addr_any, &in6addr_any, 0, 0, 0, bule->if_coa, &sel);
+	xfrm_mip_policy_del(&sel, XFRM_POLICY_OUT);
+	/* RK: instead of deleting the policy, update it to its previous state 
+	 * (the one installed in xfrm_cn_init) */
+	set_selector(&in6addr_any, &in6addr_any, IPPROTO_ICMPV6, 
+		     ND_NEIGHBOR_ADVERT, 0, 0, &sel);
+	if (xfrm_mip_policy_add(&sel, 1 /* update */, XFRM_POLICY_OUT, XFRM_POLICY_ALLOW,
+				MIP6_PRIO_NO_RO_SIG_ANY, NULL, 0) < 0)
+		XDBG("Could not update NA policy\n");
+	bule->home_block &= ~HOME_LINK_BLOCK;
 }
 
 void xfrm_unblock_link(struct home_addr_info *hai)
diff -r 82fcd4bea972 src/xfrm.h
--- a/src/xfrm.h	Fri Jan 11 16:55:08 2008 +0100
+++ b/src/xfrm.h	Fri Jan 11 17:02:25 2008 +0100
@@ -51,7 +51,8 @@ int xfrm_add_bce(const struct in6_addr *
 int xfrm_add_bce(const struct in6_addr *our_addr,
 		 const struct in6_addr *peer_addr,
 		 const struct in6_addr *coa,
-		 int replace);
+		 int replace,
+		 int create);
 
 void xfrm_del_bce(const struct in6_addr *our_addr,
 		  const struct in6_addr *peer_addr);
@@ -82,7 +83,9 @@ int cn_wildrecv_bu_pol_add(void);
 int cn_wildrecv_bu_pol_add(void);
 void cn_wildrecv_bu_pol_del(void);
 
+int xfrm_block_bule_link(struct bulentry *bule);
 int xfrm_block_link(struct home_addr_info *hai);
+void xfrm_unblock_bule_link(struct bulentry *bule);
 void xfrm_unblock_link(struct home_addr_info *hai);
 
 int xfrm_block_hoa(struct home_addr_info *hai);
